<%
Class cAlbum

  '===========================
  '## Private Class Members ##
  '===========================
  Private m_idAlbum
  Private m_folderName
  Private m_shortDescription
  Private m_longDescription
  Private m_reading
  Private m_show
  Private m_icon
  Private m_dateCreation
  Private m_userCreation
  Private m_dateLastUpdate
  Private m_userLastUpdate
  ' working property not from DB
  Private m_numberOfPhoto
  Private m_arrayPhoto()
  Private m_errorMessage

  'Read the current idAlbum value
  Public Property Get idAlbum()
      idAlbum = clng(m_idAlbum)
  End Property
  ' set idAlbum value
  Public Property Let idAlbum(p_Data)
      m_idAlbum = clng(p_Data)
  End Property
  
  ' read current folderName value
  Public Property Get folderName()
      folderName = m_folderName
  End Property
  ' set folderName value
  Public Property Let folderName(p_Data)
      m_folderName = p_Data
  End Property
  
  ' read current shortDescription value
  Public Property Get shortDescription()
      shortDescription = m_shortDescription
  End Property
  ' set shortDescription value
  Public Property Let shortDescription(p_Data)
      m_shortDescription = p_Data
  End Property
  ' read current longDescription value
  Public Property Get longDescription()
      longDescription = m_longDescription
  End Property
  ' set photoDescription value
  Public Property Let longDescription(p_Data)
      m_longDescription = p_Data
  End Property
  
  ' read current reading value
  Public Property Get reading()
      reading = m_reading
  End Property
  ' set reading value
  Public Property Let reading(p_Data)
      m_reading = p_Data
  End Property
  ' read current icon value
  Public Property Get icon()
      icon = m_icon
  End Property
  ' set icon value
  Public Property Let icon(p_Data)
      m_icon = p_Data
  End Property

  ' read current Show value
  Public Property Get show()
      show = m_show
  End Property
  ' set Show value
  Public Property Let show(p_Data)
      m_show = p_Data
  End Property
    
  ' read current dateCreation value
  Public Property Get dateCreation()
      dateCreation = m_dateCreation
  End Property
  ' set dateCreation value
  Public Property Let dateCreation(p_Data)
      m_dateCreation = p_Data
  End Property
    
  ' read current userCreation value
  Public Property Get userCreation()
      userCreation = m_userCreation
  End Property
  ' set userCreation value
  Public Property Let userCreation(p_Data)
      m_userCreation = p_Data
  End Property
    
  ' read current dateLastUpdate value
  Public Property Get dateLastUpdate()
      dateLastUpdate = m_dateLastUpdate
  End Property
  ' set dateLastUpdate value
  Public Property Let dateLastUpdate(p_Data)
      m_dateLastUpdate = p_Data
  End Property
   
  ' read current userLastUpdate value
  Public Property Get userLastUpdate()
      userLastUpdate = m_userLastUpdate
  End Property
  ' set userLastUpdate value
  Public Property Let userLastUpdate(p_Data)
      m_userLastUpdate = p_Data
  End Property

    ' read current numberOfPhoto
  Public Property Get numberOfPhoto()
      numberOfPhoto = m_numberOfPhoto
  End Property
  ' set numberOfPhoto
  Public Property Let numberOfPhoto(p_Data)
      m_numberOfPhoto = p_Data
  End Property
  
  ' read current arrayPhoto value
  Public Property Get arrayPhoto()
      arrayPhoto() = m_arrayPhoto()
  End Property
  ' set arrayPhoto() value
  Public Property Let arrayPhoto(p_Data)
      m_arrayPhoto() = p_Data
  End Property
  
  ' read current errorMessage value
  Public Property Get errorMessage()
      errorMessage = m_errorMessage
  End Property
  ' set errorMessage value
  Public Property Let errorMessage(p_Data)
      m_errorMessage = p_Data
  End Property
  
  '#############  Public Functions, accessible to the web pages ##############
    
  '===============================================================
  '## Function Load
  '            load Data with select
  '   input:
  '          folder name
  '   Returns:
  '          one record with fills class property
  '===============================================================
   Public Function Load()
          Dim strSQL
          strSQL = "SELECT Album.[idAlbum], Album.[folderName], Album.[shortDescription], Album.[longDescription], Album.[reading], Album.[show], Album.[icon], Album.[dateCreation], Album.[userCreation], Album.[dateLastUpdate], Album.[userLastUpdate] " & _
                   "FROM Album WHERE (((Album.[folderName])=" & Chr(34) & Me.folderName & Chr(34) & "))"   
          Load = LoadData (strSQL)
   End Function

  '===============================================================
  '## Function LoadAlbumWithPhoto
  '            load Album and its photo (file system and db)
  '   input:
  '            folderName
  '   Returns:
  '            Album class with its photo inside arrayPhoto
  '===============================================================
   Public Function LoadAlbumWithPhoto()

          Dim arrPhoto()
          Dim album: album = Me.folderName
          
          ' create file system object
          Dim FileObject
          Set FileObject = Server.CreateObject("Scripting.FileSystemObject")
          
          ' control if album already exist
          If FileObject.FolderExists(Request.ServerVariables("APPL_PHYSICAL_PATH") & Path_FotoAlbum & Me.folderName) Then
             
             ' load album info
             Me.Load()
             If Me.errorMessage <> "" Then
                Me.shortDescription = Me.folderName 
             End If
             
             'load Photo list
             'Dim objPhoto
             'Set objPhoto = New cPhoto
             'Me.arrayPhoto = cPhoto.listPhotoByFolderName(Me.idAlbum, Me.folderName)
						 'If IsArray(Me.arrayPhoto) Then
						 '	  LoadAlbumWithPhoto = True
						 'Else
						 '	  LoadAlbumWithPhoto = False
						 '	  Me.errorMessage = cPhoto.errorMessage
					   'End If
          Else
             LoadAlbumWithPhoto = False
             Me.errorMessage = Errore_Album_NonTrovato
          End If
          
   End Function

  '===============================================================
  '## Function ListAlbum
  '            load an array of Album
  '   input:
  '            nothing
  '   Returns:
  '            an array of Album
  '            test errorMessage (if blank all ok)
  '===============================================================
   Public Function ListAlbum()

          ' create file system object
          Dim FileObject, arrayAlbum(), ind
          
          ind = 0
          Set FileObject = Server.CreateObject("Scripting.FileSystemObject")
          
          ' control if exists the folder indicated by config file
          If FileObject.FolderExists(Request.ServerVariables("APPL_PHYSICAL_PATH") & Path_FotoAlbum) Then
            
             Set f = FileObject.GetFolder(Request.ServerVariables("APPL_PHYSICAL_PATH") & Path_FotoAlbum)
             Set fc = f.SubFolders
        
             ' count existing direcotry (or Album)
             For Each f1 in fc
                 ind = ind + 1
             Next
             
             If ind = 0 Then
             	  ListAlbum = False
                Me.errorMessage = Errore_Album_NonTrovato
             Else
						    ' set the dimension of array
   						  Redim arrayAlbum(ind)
   						  
   						  ' reset ind
   						  ind = 0

                For Each f1 in fc
                    Set objAlbum = New cAlbum
                    objAlbum.folderName = f1.name
                    objAlbum.Load()
                    
                    If isEmpty(objAlbum.shortDescription) or IsNull(objAlbum.shortDescription) Then
                       objAlbum.shortDescription = f1.name
                    End If

                    'objAlbum.echoAlbum()
                    
                    Set arrayAlbum(ind) = objAlbum
                    
                    ind = ind + 1
                    
                    Set objAlbum = Nothing
                Next
             	  
             	  ListAlbum = arrayAlbum
                Me.errorMessage = ""             	  
             End If
          Else
          	 ListAlbum = False
             Me.errorMessage = Errore_Album_PathNotFound
          End If

          Set fc = Nothing
          Set f = Nothing
          Set FileObject = Nothing
        
   End Function
  '===============================================================
  '## Function Exist
  '            verify if an album exist
  '   input:
  '            folder name
  '   Returns:
  '            Boolean (True = exist | False = not exist)
  '===============================================================
   Public Function Exist()
          Dim strSQL, oDB, rs
          strSQL = "SELECT Album.[idAlbum], Album.[folderName], Album.[shortDescription], Album.[longDescription], Album.[reading], Album.[show], Album.[icon], Album.[dateCreation], Album.[userCreation], Album.[dateLastUpdate], Album.[userLastUpdate] " & _
                   "FROM Album WHERE (((Album.[folderName])=" & Chr(34) & Me.folderName & Chr(34) & "))"
           
          Set oDB  = New cDBUtils
          Set rs   = oDB.ExecuteInlineSql(strSQL)
            
          If oDB.ErrorCount > 0 Then
             Exist = False
             Me.errorMessage = "ERROR!!!" & oDB.ErrorDescription & " " & oDB.ErrorNumber
          Else
             Select Case rs.recordCount
                  Case 0
                         Exist = False
                         Me.errorMessage = Errore_Album_NonTrovato
                  Case 1
                         Exist = True
                         ' album found
                    Case Else     
                         Exist = False
                         Me.errorMessage = Errore_Album_NonUnivoco
             End Select
          End If
          
          rs.close
          Set rs   = Nothing
          Set oDB  = Nothing
   End Function

  '===============================================================
  '## Function generateDropDownSelectionList
  '            Load Album list from  file system and integrate 
  '            info with Data Base information if exists
  '   input:
  '          a string contains the folder name to set selected
  '   Returns:
  '          - on error return space and popolate errorMessage
  '          - in all ok return a string contains album list:
  '          <FORM NAME="URLlist">
  '          <Select NAME="droplist" onchange="GotoURL(document.URLlist)"
  '               <option>Album 1</option>
  '               <option>Album 2</option>
  '               <option>Album ...</option>
  '              </select>
  '          </FORM>
  '===============================================================
   Public Function generateDropDownSelectionList(strFolderSelected)
       
          Dim arrayOfAlbum
          Dim strAlbumList: strAlbumList = ""
         
          arrayOfAlbum = Me.ListAlbum()
          
          If Me.errorMessage = "" Then

             'strAlbumList = strAlbumList & "<FORM NAME="&Chr(34)&"URLlist"&Chr(34)&">"
             strAlbumList = strAlbumList & "<select NAME="&Chr(34)&"droplist"&Chr(34)&" onchange="&Chr(34)&"GotoURL(document.URLlist)"&Chr(34)
             strAlbumList = strAlbumList & "<option></option>"
             
             For i = 0 to Ubound(arrayOfAlbum)-1
                 Dim objAlbum
                 Set objAlbum = arrayOfAlbum(i)

                 strAlbumList = strAlbumList & "<option"  
                 if objAlbum.folderName = strFolderSelected Then
                    strAlbumList = strAlbumList & " selected "
                 end if       
                 strAlbumList = strAlbumList & " value='" & objAlbum.folderName & "'>" & objAlbum.shortDescription & "</option>"

                 Set objAlbum = Nothing
             Next

             ' chiusura select e form
             'strAlbumList = strAlbumList & "</select></FORM>"
             strAlbumList = strAlbumList & "</select>"
             generateDropDownSelectionList = strAlbumList
             Me.errorMessage = ""
          Else
             'report error on listAlbum method
             generateDropDownSelectionList = ""
          End If
          
  End Function
  
  '===============================================================
  '## Function numberOfAlbum
  '            count Album
  '   input:
  '          none
  '   Returns:
  '          int: number of Album
  '===============================================================
   Public Function numberOfAlbum()
    
          Dim ind: ind = 0
          
          ' create file system object
          Dim FileObject
          Set FileObject = Server.CreateObject("Scripting.FileSystemObject")
          
          ' control if exists the folder indicated by config file
          If FileObject.FolderExists(Request.ServerVariables("APPL_PHYSICAL_PATH") & Path_FotoAlbum) Then
             Set f = FileObject.GetFolder(Request.ServerVariables("APPL_PHYSICAL_PATH") & Path_FotoAlbum)
             Set fc = f.SubFolders
             For Each f1 in fc
                ind = ind + 1
             Next
          Else
             Me.errorMessage = Errore_Album_PathNotFound
          End If
    
          Set fc = Nothing
          Set f = Nothing
          Set FileObject = Nothing     
       
          numberOfAlbum = ind
   End Function

  '===============================================================
  '## Function Update
  '            update Data
  '   input:
  '          set all class Property
  ' example:
  '
  '   Returns:
  '            Boolean (True = exist | False = not exist)
  '===============================================================        
   Public Function Update()
 
          Dim oDB, parameterArray, strValues, strColoumnName
          Dim strClause, numberOfParameter, strSeparator
       
          strSeparator = "|"
          
          Set oDB = New cDBUtils
          numberOfParameter = 0

          If Me.shortDescription <> "" Then
             numberOfParameter = numberOfParameter + 1
             strColoumnName = strColoumnName & "Album.[shortDescription]" & strSeparator
             strValues = strValues & "'" & DecodeEntities(SostituisciCaratteri(DoppioApice(Me.shortDescription), "No")) & "'" & strSeparator
          End If
          
          If Me.longDescription <> "" Then
             numberOfParameter = numberOfParameter + 1
             strColoumnName = strColoumnName & "Album.[longDescription]" & strSeparator
             strValues = strValues & "'" & DecodeEntities(SostituisciCaratteri(DoppioApice(Me.longDescription), "No")) & "'" & strSeparator
          End If

          If Me.icon <> "" Then
             numberOfParameter = numberOfParameter + 1
             strColoumnName = strColoumnName & "Album.[icon]" & strSeparator
             strValues = strValues & "'" & Replace(Me.icon, "'", "''") & "'" & strSeparator
          End If
   
          numberOfParameter = numberOfParameter + 1
          strColoumnName = strColoumnName & "Album.[dateLastUpdate]" & strSeparator
          strValues = strValues & "'" & Now() & "'" & strSeparator
            
          numberOfParameter = numberOfParameter + 1
          strColoumnName = strColoumnName & "Album.[userLastUpdate]" & strSeparator
          strValues = strValues & "'" & Me.userLastUpdate & "'" & strSeparator
       
       
          Dim i, arrColoumnName, arrValues
          arrColoumnName = Split(strColoumnName, strSeparator)
          arrValues = Split(strValues, strSeparator) 
          ReDim parameterArray(UBound(arrColoumnName), 1)
          
          For i = 1 To UBound(arrColoumnName)
            parameterArray(i,0) = arrColoumnName(i-1)
            parameterArray(i,1) = arrValues(i-1)
          Next
       
          'Call UpdateData specifying 
          ' 1 - Table to Update
          ' 2 - Array of Field / value pairs to update
          ' 3 - Option SQL Clause (Pass in "" to update with no Clause)
          strClause = " WHERE (Album.[folderName] = '" & Me.folderName & "')"
          WhatNow = oDB.UpdateData("Album", parameterArray, strClause)
       
          IF oDB.ErrorCount > 0 Then
             Update = False 
             Me.errorMessage = "ERROR!!!" & oDB.ErrorDescription & " " & oDB.ErrorNumber
          Else
             Update = True
          End If
   
          Set oDB = Nothing
   End Function

  '===============================================================
  '## Function increaseNumberOfReading
  '            increase the number of visualizzation
  '   input:
  '            folderName
  ' example:
  '            Dim Album: set Album = new cAlbum
  '            Album.folderName = "photoAlbum"
  '            Album.increaseNumberOfReading()
  '   Returns:
  '            Boolean (True = exist | False = not exist)
  '===============================================================        
   Public Function increaseNumberOfReading()
 
          Dim oDB, strSQL
          Set oDB = New cDBUtils
          strSQl  = "UPDATE Album SET Album.reading = [Album].[reading]+1 " & _
                    "WHERE (((Album.folderName)=" & Chr(34) & Me.folderName & Chr(34) & "))"       
          oDB.RunSQL(strSQL)
          IF oDB.ErrorCount > 0 Then
             increaseNumberOfReading = False 
             Me.errorMessage = "ERROR!!!" & oDB.ErrorDescription & " " & oDB.ErrorNumber
          Else
             increaseNumberOfReading = True
          End If
   
          Set oDB = Nothing
   End Function
  
  '===============================================================
  '## Function DeleteByAlbumID (work in progress)
  '            delete album and all its photo and comment
  '   input:
  '            set idAlbum
  ' example:
  '            Dim Album: set Album = new cAlbum
  '            Album.idAlbum = 1
  '            Album.DeleteByAlbumID()
  '   Returns:
  '            nothing, on error roll back write message 
  '            and stop execution
  '===============================================================        
   Public Function DeleteByAlbumID()
          Dim oDB, haveDeletedComment, haveDeletedPhoto, haveDeletedAlbum
          Set oDB = New cDBUtils
          
          ' delete all photo's comment
          strSQL = "DELETE FROM photoComment WHERE idComment = (SELECT PhotoComment.idComment FROM (Album INNER JOIN Photo ON Album.idAlbum = Photo.idAlbum) INNER JOIN PhotoComment ON Photo.idPhoto = PhotoComment.idPhoto WHERE (((Album.idAlbum)=" & Me.idAlbum & ")))"
          haveDeletedComment = oDB.RunSQL(strSQL)     
          If NOT haveDeletedComment Then
             DeleteByAlbumID = False
             Me.errorMessage = Errore_ImpossibileCancellareCommenti & " " & oDB.ErrorDescription & " " & oDB.ErrorNumber
             Exit Function
          End If
          
          ' delete all album's photo
          strSQL = "DELETE FROM Photo WHERE idAlbum = " & Me.idAlbum
          haveDeletedPhoto = oDB.RunSQL(strSQL)
          If NOT haveDeletedPhoto Then
             DeleteByAlbumID = False
             Me.errorMessage = Errore_ImpossibileCancellarePhoto & " " & oDB.ErrorDescription & " " & oDB.ErrorNumber
             Exit Function
          End If
          
          ' delete Album
          strSQL = "delete FROM Album WHERE IdAlbum = '" & Me.idAlbum & "'"
          haveDeletedAlbum = oDB.RunSQL(strSQL)
          If NOT haveDeletedAlbum Then
             DeleteByAlbumID = False
             Me.errorMessage = Errore_ImpossibileCancellareAlbum & " " & oDB.ErrorDescription & " " & oDB.ErrorNumber
             Exit Function
          End If
          
          Set oDB = Nothing
   End Function
     
  '===============================================================
  '## Function AddNewAlbum
  '            insert a new Album
  '   input:
  '          set class property
  ' example:
  '            Dim Album: set Album = new cAlbum
  '      Album.folderName = "photoAlbum"
  '            Album.shortDescription = "short description"
  '                            .
  '                            .
  '                            .
  '      Album.AddNewAlbum()
  '   Returns:
  '          Boolean (True = Success | False = Error)
  '===============================================================        
   Public Function AddNewAlbum()
     
         Dim vArray(8,1), tblName
         Me.errorMessage = ""
         
         tblName = "Album" ' don't add square parentesis

         vArray(1,0) = "[folderName]" 'ColumnName
         vArray(1,1) = "'" & Me.folderName & "'" 'Value to insert (notice the single quotes for types that required them!)
         
         vArray(2,0) = "[shortDescription]"
         If Me.shortDescription = "" Then
            vArray(2,1) = Null
         Else
         
            vArray(2,1) = "'" & DecodeEntities(SostituisciCaratteri(DoppioApice(Me.shortDescription), "No")) & "'"
         End If
         
         vArray(3,0) = "[longDescription]"
         If Me.longDescription = "" Then
            vArray(3,1) = Null
         Else
            vArray(3,1) = "'" & DecodeEntities(SostituisciCaratteri(DoppioApice(Me.longDescription), "No")) & "'"
         End If
         
         vArray(4,0) = "[reading]"
         If Me.reading = "" Then
            vArray(4,1) = 0
         Else
            vArray(4,1) = CInt(Me.reading)
         End If
                  
         vArray(5,0) = "[dateCreation]"
         vArray(5,1) = "'" & Now() & "'"
         
         vArray(6,0) = "[userCreation]"
         vArray(6,1) = "'" & Request.ServerVariables("REMOTE_ADDR") & "'" ' store user ip address          
         
         vArray(7,0) = "[dateLastUpdate]"
         vArray(7,1) = "'" & Now() & "'"
         
         vArray(8,0) = "[userLastUpdate]"
         vArray(8,1) = "'" & Request.ServerVariables("REMOTE_ADDR") & "'" ' store user ip address
    
         Dim oDB, bWhat
         Set oDB = New cDBUtils 
         bWhat = oDB.InsertData(tblName, vArray)
      
         IF oDB.ErrorCount > 0 Then
            AddNewAlbum = False
            Me.errorMessage = "ERROR!!!" & oDB.ErrorDescription & " " & oDB.ErrorNumber
         Else
            AddNewAlbum = True
         End If
        
         Set oDb = Nothing
         
    End Function

   '===============================================================
   '## Function EchoAlbum
   '            Print in html the information of Album
   '   input:   Nothing
   '   Returns: Nothing
   '===============================================================
    Public Function EchoAlbum()
           Response.Write "<hr>"
           Response.Write "Informazioni sull'Album numero <b>" & Me.idAlbum & "</b><br/>"
           Response.Write "folderName : <b>" & Me.folderName & "</b><br/>"
           Response.Write "shortDescription : <b>" & Me.shortDescription & "</b><br/>"
           Response.Write "longDescription : <b>" & Me.longDescription & "</b><br/>"
           Response.Write "reading : <b>" & Me.reading & "</b><br/>"
           Response.Write "show : <b>" & Me.show & "</b><br/>"
           Response.Write "icon : <b>" & Me.icon & "</b><br/>"
           Response.Write "numberOfAlbum : <b>" & Me.numberOfAlbum & "</b><br/>"
           Response.Write "dateCreation : <b>" & Me.dateCreation & "</b><br/>"
           Response.Write "userCreation : <b>" & Me.userCreation & "</b><br/>"
           Response.Write "dateLastUpdate : <b>" & Me.dateLastUpdate & "</b><br/>"
           Response.Write "userLastUpdate : <b>" & Me.userLastUpdate & "</b><br/>"
           Response.Write "<hr>"
   End Function
     
     
     '#############           PRIVATE FUNCTION        #############   
        
    '===============================================================
    '## Function LoadData
    '            Loads this object's property by loading a record 
    '            from Data Base
    '   input:   Sql select
    '   Returns: fills properties of tha Album class using FillFromRS
    '===============================================================
      Private Function LoadData(p_strSQL)
              Dim oDB, rs
              Set oDB  = New cDBUtils
              Set rs   = oDB.ExecuteInlineSql(p_strSQL)
              LoadData = FillFromRS(rs)
              rs.close
              Set rs   = Nothing
              Set oDB  = Nothing
      End Function

      '===============================================================
    '## Function FillFromRS
      '            Fills the Album's class properties using 
      '            the recordset
    '   input:   Album recordset
    '   Returns: Boolean True (fills properties of tha Album class)
    '            or False (Non Found or other Error)
    '===============================================================
      Private Function FillFromRS(p_rs)
              
              Select Case p_rs.recordCount
                Case 1
                    Me.idAlbum            = p_rs.fields("idAlbum").Value
                    Me.folderName         = p_rs.fields("folderName").Value
                    Me.shortDescription   = Trim(replace(server.HTMLEncode(p_rs.fields("shortDescription").Value),"''","'"))
                    Me.longDescription    = Trim(replace(server.HTMLEncode(p_rs.fields("longDescription").Value),"''","'"))
                    Me.reading            = p_rs.fields("reading").Value
                    Me.show               = p_rs.fields("show").Value
                    Me.icon               = p_rs.fields("icon").Value
                    Me.dateCreation       = p_rs.fields("dateCreation").Value
                    Me.userCreation       = p_rs.fields("userCreation").Value
                    Me.dateLastUpdate     = p_rs.fields("dateLastUpdate").Value
                    Me.userLastUpdate     = p_rs.fields("userLastUpdate").Value
                    FillFromRS            = True
                    Me.errorMessage       = ""
                Case -1, 0
                    FillFromRS            = False
                    Me.errorMessage       = Errore_Album_NonTrovato
                Case Else
                    FillFromRS            = False
                    Me.errorMessage       = Errore_Album_NonUnivoco
              End Select
              
      End Function
      
    '================================
    ' Class Constructor / Initializer
    '================================ 
    Private Sub Class_Initialize()
            'Do Nothing
    End Sub
    
    '=========================================
    '## Class_Terminate           ##
    '## Fires during class destruction    ##
    '=========================================
    Private Sub Class_Terminate()
      'Do Nothing
    End Sub
    
End Class
%>