<%
'==================================================
'  Generic ASP Data Access Class (MOD by Mago28)
'  
'  Jason Withrow - 2004 - jason@myveryownwebsite.com
'
'  Adolfo Trinca - 2006 - adolfo.trinca@email.it
'               http://www.adolfo.trinca.name
'
'  Distribute Freely - Enjoy but don't remove this
'
'==================================================
Class cDBUtils


  '===========================
  '## Private Class Members ##
  '===========================
  Private m_sConnect
  Private m_oConnection
  Private m_oTempRS
  Private m_lErrorNumber
  Private m_sErrDescription
  Private m_lErrorCount
  Private vbQuote
  
  
  '=============================================
  '## Public Error Number Class Property    ##
  '=============================================
  Public Property Get ErrorNumber()
    ErrorNumber = m_lErrorNumber
  End Property
  
  Public Property Let ErrorNumber(lInput)
    m_lErrorNumber = lInput
  End Property
  
  
  '=================================================
  '## Public Error Description Class Property   ##
  ' holds error msg for LAST error encountered 
  '================================================
  Public Property Get ErrorDescription()
    ErrorDescription = m_sErrDescription
  End Property
  
  Public Property Let ErrorDescription(sInput)
    m_sErrDescription = sInput
  End Property
  
  '=============================================
  '## Public Error Count Class Property   ##
  '=============================================
  Public Property Get ErrorCount()
    ErrorCount = m_lErrorCount
  End Property
  
  Public Property Let ErrorCount(lInput)
    m_lErrorCount = lInput
  End Property
  
  
  '=====================================
  '## Private ADO Connection Property ##
  '=====================================
  Private Property Get Connection()
          'IF m_oConnection is an object and Connection is not already Set
          'Create a New instance of Connection Property, otherwise reuse existing 
          If isObject(m_oConnection) AND Not isObject(Connection) Then
             Set Connection = m_oConnection
          End IF
  End Property
  
  Private Property Set Connection(oInput)
          IF Not isObject(m_oConnection) Then
             Set m_oConnection = oInput
          End IF
  End Property
  
  '=============================================
  '## Public Read/Write ADO Connection String ##
  '=============================================
  Public Property Get ConnectionString()
         ConnectionString = m_sConnect
  End Property
  
  Public Property Let ConnectionString(sInput)
         m_sConnect = sInput
  End Property
  
  Private Sub OpenConnection()
          IF isObject(Connection) Then
            IF (Connection.State = 0) Then
              Connection.Open ConnectionString
            End IF
          Else
            Set Connection = Server.CreateObject("ADODB.Connection")
            Connection.Open ConnectionString
          End IF
  End Sub
  
  '=====================================
  '## Private CloseConnection     ##
  '## {Closes an Open Connection}   ##
  '=====================================
  Private Sub CloseConnection()
          IF isObject(Connection) AND (Connection.State > 0) Then
            Connection.Close
          End IF
  End Sub
  
  '=====================================================
  '## Private GetStatus               ##
  '## Returns The State of the Connection       ##
  '## Used internally to determine Connection Status  ##
  '=====================================================
  Private Function GetStatus()
          IF isObject(Connection) Then
            GetStatus = Connection.State
          Else
            GetStatus = 0
          End IF
  End Function
  
  '===============================================================
  '## Function Insertdata
  ' Inserts Data into DB via inline inserts
  ' Returns:
  ' Boolean (True = Success | False = Error)
  '===============================================================
  Public Function InsertData(sTableName, [ParamArray])
    
         Dim uBoundX, tempString
         Dim iNameIterator, iValueIterator
         Dim sql, oCommand
         
         IF Not isArray([ParamArray]) Then
            IncrementErrorCount
            AddErrortext("Array expected in cDBUtils:InsertData")
            AddErrorNumber(1303)
            InsertData = False
            Exit Function
         End IF
         
         tempString = "INSERT INTO [" & sTableName & "] ("
         
         'On Error Resume Next
         uBoundX = uBound([ParamArray],1)
         
         For iNameIterator = 0 to uBoundX
             IF (iNameIterator <> 0) AND (iNameIterator <> uBoundX) AND (iNameIterator > 0) Then
                tempString = tempString & [ParamArray](iNameIterator,0) & ","
             Else
                tempString = tempString & [ParamArray](iNameIterator,0)
             End IF
         Next
           
         tempString = tempString & ") VALUES ("
           
         For iValueIterator = 0 to uBoundX
             IF (iValueIterator <> 0) AND (iValueIterator <> uBoundX) AND (iValueIterator > 0) Then
                IF isNull([ParamArray](iValueIterator,1)) Then
                   tempString = tempString & "'<NULL>'" & ","
                Else
                   tempString = tempString & [ParamArray](iValueIterator,1) & ","
                End IF
             Else
                IF isNull([ParamArray](iValueIterator,1)) Then
                   tempString = tempString & "'<NULL>'"
                Else
                   tempString = tempString & [ParamArray](iValueIterator,1)
                End IF
             End IF
         Next
         
         tempString = tempString & ")"
         
         sql = tempString
         
         On Error Resume Next
         
         OpenConnection
         Set oCommand = Server.CreateObject("ADODB.Command")
             oCommand.ActiveConnection = Connection
             oCommand.CommandType = &H0001
             oCommand.CommandText = sql
             oCommand.Execute sql
         Set oCommand = Nothing
     
         IF err.number <> 0 Then
            IncrementErrorCount
            AddErrortext(err.Description & " in cDBUtils:InsertData")
            AddErrorNumber(1304)
            InsertData = False
         Else
            InsertData = True
         End If
         
  End Function
  
  
  '===============================================================
  '## Function UpdateData
  ' Updates Data via inline inserts
  ' Returns:
  ' Boolean (True = Success | False = Error)
  '===============================================================
  Public Function UpdateData(sTableName, [ParamArray], sClause)
         Dim uBoundX, tempString
         Dim iNameIterator, iValueIterator
         Dim sql, oCommand
         
         IF Not isArray([ParamArray]) Then
            IncrementErrorCount
            AddErrortext("Array expected in cDBUtils:UpdateData")
            AddErrorNumber(1307)
            InsertData = False
            Exit Function
         End If
         
         tempString = "UPDATE [" & sTableName & "] SET "
         
         On Error Resume Next
         uBoundX = uBound([ParamArray],1)
         
         For iNameIterator = 1 To uBoundX-1
             IF (iNameIterator <> 0) AND (iNameIterator <> uBoundX-1) AND (iNameIterator > 0) Then
                tempString = tempString & [ParamArray](iNameIterator,0) & " = " & [ParamArray](iNameIterator,1) & ","
             Else
                tempString = tempString & [ParamArray](iNameIterator,0) & " = " & [ParamArray](iNameIterator,1)
             End If
         Next
       
         sql = tempString & " " & sClause
         
         On Error Resume Next
         
         OpenConnection
         Connection.BeginTrans
         
         Set oCommand = Server.CreateObject("ADODB.Command")
             oCommand.ActiveConnection = Connection
             oCommand.CommandType = &H0001
             oCommand.CommandText = sql
             oCommand.Execute sql
         Set oCommand = Nothing
     
         If Err.Number <> 0 Then
            IncrementErrorCount
            AddErrortext(err.Description & " in cDBUtils:UpdateData")
            AddErrorNumber(1308)
            UpdateData = False
            Connection.RollbackTrans 
         Else
            UpdateData = True
            Connection.CommitTrans
         End If
         
  End Function  
  
  Private Function NullHelper(sInput)
          If isNull(sInput) or isEmpty(sInput) Then
             NullHelper = "'<NULL>'"
          End IF
  End Function
  
  
  Public Function ExecuteInlineSql(sql)
  
         On Error Resume Next
    
         OpenConnection
         Set m_oTempRS = Server.CreateObject("ADODB.RecordSet")
         m_oTempRS.Open sql, Connection, 3, 2
     
         If err.number <> 0 Then
            IncrementErrorCount
            AddErrortext(Err.Description &  " in cDBUtils:ExecuteInlineSql")
            AddErrorNumber(1305)
            ExecuteInlineSql = False
         Else
            Set ExecuteInlineSql = m_oTempRS
         End IF
         
  End Function
  
  
  
  Public Function ExecProc(sProc, [ParamArray])

    
         Dim uBoundX, uBoundY, tempString
    
         On Error Resume Next
         '======================================
         ' Determine if proc has params
         '======================================
         IF isArray([ParamArray]) Then
            uBoundX  = uBound([ParamArray])

            Dim iValueIterator
            
            tempString = "EXEC " & sProc & " "
            
            'Retrieve param names
            For iValueIterator = 0 to uBoundX
                IF (iValueIterator <> 0) AND (iValueIterator <> uBoundX) AND (iValueIterator > 0) Then
                   tempString = tempString & [ParamArray](iValueIterator) & ","
                Else
                   tempString = tempString & [ParamArray](iValueIterator)
                End IF
            Next
         Else
            tempString = "EXEC " & sProc 
         End IF
         
         Dim sql
         sql = tempString
         
         OpenConnection
         
         Set m_oTempRS = Server.CreateObject("ADODB.RecordSet")
         m_oTempRS.Open sql, Connection, 3, 2
          
         IF err.number <> 0 Then
            IncrementErrorCount
            AddErrortext(Err.Description &  " in cDBUtils:ExecProc")
            AddErrorNumber(1306)
            ExecProc = False
         Else
            Set ExecProc = m_oTempRS
         End If
  
  End Function  
  
  '===============================================================
  '## Function RunSQL
  '            Execute the query without returning a recordset
  '   input:
  '          sql statement
  '   Returns:
  '          Boolean (True = Success | False = Error)
  '===============================================================
   Public Function RunSQL(ByVal sql)
        
          If isEmpty(sql) or IsNull(sql) Then
             IncrementErrorCount
             AddErrortext("Empty SQL statement in cDBUtils:RunSQL")
             AddErrorNumber(1309)
             RunSQL = False
             Exit Function
          End If
        
          On Error Resume Next
    
          OpenConnection
          Set oCommand = Server.CreateObject("ADODB.Command")
            oCommand.ActiveConnection = Connection
            oCommand.ActiveConnection.BeginTrans
            oCommand.CommandType = &H0001
            oCommand.CommandText = sql
            oCommand.Execute sql
      
          IF err.number <> 0 Then
             oCommand.ActiveConnection.RollBackTrans
             IncrementErrorCount
             AddErrortext(err.Number & " " & err.Description & " in cDBUtils:RunSQL")
             AddErrorNumber(1310)
             RunSQL = False
          Else
             oCommand.ActiveConnection.CommitTrans
             RunSQL = True
          End If
          
          Set oCommand = Nothing

  End Function

  
  Private Sub IncrementErrorCount()
          ErrorCount = (ErrorCount + 1)
  End Sub
  
  Private Sub AddErrorText(sInput)
          ErrorDescription = sInput
  End Sub
  
  Private Sub AddErrorNumber(lInput)
          ErrorNumber = lInput
  End Sub
  
  
  '============================================================
  '## Public ResetErrors
  ' Returns : nothing
  ' Resets Error Properties
  ' Use this to reset error properties of this class
  '===========================================================
  Public Sub ResetErrors()
         ErrorCount = 0
         ErrorDescription = Null
         ErrorNumber = 0
  End Sub
  
  
  '===================================================
  ' Public Function RS2XL
  ' Input: RecordSet Object
  ' OutPut: XML String - format below:
  ' <ROW index=1>
  ' <ColumnName>Column value</ColumnName>
  '</ROW>
  '===================================================
  Public Function RS2XML(byRef oRS)
  
         If Not isObject(oRS) Then
            IncrementErrorCount
            AddErrorText("RecordSet Expected in method cDBUtils:RS2XML")
            AddErrorNumber(1301)
            Exit Function
         End IF
     
         Dim iRowCount, iColCount
         Dim tempString, sElementName
         iRowCount = 1
         
         On Error Resume Next
         
         oRS.MoveFirst
         tempString = "<" & Connection.DefaultDatabase & ">" & vbCrLf
         Do While Not oRS.EOF
            tempString = (tempString & "<ROW Index=" & vbQuote & iRowCount & vbQuote & ">" & vbCrLf)
            For iColCount = 0 To oRS.Fields.Count - 1
                sElementName = oRS.Fields(iColCount).Name
                tempString = (tempString & "<" & sElementName & ">" & Validify(oRS.Fields(iColCount).Value) & "</" & sElementName & ">" & vbCrLf)
            Next
            tempString = tempString & "</ROW>" & VbCrLf
            oRS.MoveNext
            iRowCount = (iRowCount + 1)
         Loop
         
         tempString = (tempString & "</" & Connection.DefaultDatabase & ">")
         
         If err.number <> 0 Then
            IncrementErrorCount
            AddErrorText(err.Description & " in method RS2XML")
            AddErrorNumber(1302)
            RS2XML = False
         Else
            RS2XML = tempString
         End IF
         
         Set oRS = Nothing
    
  End Function
  
  Private Function Validify(sInput)
          sInput = Replace(sInput, "]", "")
          sInput = Server.HTMLEncode(sInput)
          
          Validify = sInput
  End Function
  
  '=========================================
  '## Class_Terminate           ##
  '## Fires during class destruction    ##
  '=========================================
  Private Sub Class_Terminate()
          If IsObject(m_oConnection) Then
             CloseConnection
             Set m_oConnection = Nothing
          End IF
          
          If isObject(m_oTempRS) Then
             If m_oTempRS.State > 0 Then
                m_oTempRS.Close
             End IF
             Set m_oTempRS = Nothing
          End IF
  End Sub
  
  '================================
  ' Class Constructor / Initializer
  '================================
  Private Sub Class_Initialize()
          vbQuote = Chr(34)
          'Place ConnectionString Here 
          'ConnectionString = "Provider = Microsoft.Jet.OLEDB.4.0; Data Source = "& Server.MapPath(Path_DirScrittura & "DAlbum.mdb") &";"
          ConnectionString = "Provider = Microsoft.Jet.OLEDB.4.0; Data Source = "& Server.MapPath("/mdb-database/DAlbum.mdb") &";"
          ErrorCount = 0
          ErrorDescription = Null
          ErrorNumber = 0
  End Sub

End Class
%>